gconf-cache revision 5887
800N/A#!/bin/ksh -p
800N/A#
1276N/A# Copyright (c) 2008, 2011, Oracle and/or its affiliates. All rights reserved.
800N/A#
1276N/A# Permission is hereby granted, free of charge, to any person obtaining a
800N/A# copy of this software and associated documentation files (the
800N/A# "Software"), to deal in the Software without restriction, including
919N/A# without limitation the rights to use, copy, modify, merge, publish,
919N/A# distribute, and/or sell copies of the Software, and to permit persons
919N/A# to whom the Software is furnished to do so, provided that the above
919N/A# copyright notice(s) and this permission notice appear in all copies of
919N/A# the Software and that both the above copyright notice(s) and this
919N/A# permission notice appear in supporting documentation.
919N/A#
919N/A# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
919N/A# OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
919N/A# MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT
919N/A# OF THIRD PARTY RIGHTS. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR
919N/A# HOLDERS INCLUDED IN THIS NOTICE BE LIABLE FOR ANY CLAIM, OR ANY SPECIAL
919N/A# INDIRECT OR CONSEQUENTIAL DAMAGES, OR ANY DAMAGES WHATSOEVER RESULTING
919N/A# FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT,
919N/A# NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION
919N/A# WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
919N/A#
800N/A# Except as contained in this notice, the name of a copyright holder
800N/A# shall not be used in advertising or otherwise to promote the sale, use
800N/A# or other dealings in this Software without prior written authorization
800N/A# of the copyright holder.
800N/A#
800N/A###########################################################################
800N/A#
1276N/A
800N/APATH=/usr/bin:/usr/sbin
911N/A
1276N/A. /lib/svc/share/smf_include.sh
1276N/A
1276N/AUSAGE="Usage: $0 { start | refresh }"
911N/AFIND_NEWER=/usr/share/desktop-cache/find_newer
970N/A
977N/Aif [ $# -ne 1 ] ; then
970N/A echo $USAGE
970N/A exit 2
970N/Afi
970N/A
970N/A#
800N/A# IF the gconf cache exist then :
800N/A# find schema files newer than the cache
800N/A# ELSE
800N/A# get all schema file
800N/A#
970N/A# generate/merge schema files in the gconf cache
970N/A#
970N/AGCONFDIR="/etc/gconf"
1196N/Astart_gconf_cache ()
1196N/A{
1196N/Atest -w $GCONFDIR || {
1196N/A echo "$GCONFDIR is not writable, skipping."
800N/A return
}
if [ -a "/etc/gconf/gconf.xml.defaults/%gconf-tree.xml" ]; then
SCHEMAS=`${FIND_NEWER} -f -m -c --name '*.schemas' \
--newer /etc/gconf/gconf.xml.defaults/%gconf-tree.xml \
/etc/gconf/schemas 2>/dev/null`
ENTRIES=`${FIND_NEWER} -f -m -c --name '*.entries' \
--newer /etc/gconf/gconf.xml.defaults/%gconf-tree.xml \
/etc/gconf/schemas 2>/dev/null`
else
SCHEMAS=`/usr/bin/find /etc/gconf/schemas -name '*.schemas' ! -type d`
ENTRIES=`/usr/bin/find /etc/gconf/schemas -name '*.entries' ! -type d`
fi
if [ -n "$SCHEMAS" ]; then
test -x /usr/bin/gconftool-2 || {
echo "gconftool-2 not installed"
return
}
echo "Updating GConf cache for the following schemas:"
echo "$SCHEMAS" | /bin/sed -e 's/^/ /'
# redirect stdout to /dev/null because gconftool is too verbose
# errors are printed to stderr
GCONF_CONFIG_SOURCE=xml:merged:/etc/gconf/gconf.xml.defaults \
/usr/bin/gconftool-2 --makefile-install-rule $SCHEMAS > /dev/null
if [ $? -ne 0 ]; then
echo "gconftool-2 exited with an error while installing schemas"
exit $SMF_EXIT_ERR_FATAL
else
echo "Schema files merged in the GConf cache"
fi
fi
if [ -n "$ENTRIES" ]; then
test -x /usr/bin/gconftool-2 || {
echo "gconftool-2 not installed"
return
}
echo "Updating GConf cache for the following entries:"
echo "$ENTRIES" | /bin/sed -e 's/^/ /'
# redirect stdout to /dev/null because gconftool is too verbose
# errors are printed to stderr
/usr/bin/gconftool-2 --direct \
--config-source=xml:merged:/etc/gconf/gconf.xml.defaults \
--load $ENTRIES > /dev/null
if [ $? -ne 0 ]; then
echo "gconftool-2 exited with an error while adding entries"
exit $SMF_EXIT_ERR_FATAL
else
echo "Entries merged into the GConf cache"
fi
fi
}
refresh_gconf_cache ()
{
test -w $GCONFDIR || {
echo "$GCONFDIR is not writable, skipping."
return
}
if [ -a "/etc/gconf/gconf.xml.defaults/%gconf-tree.xml" ]; then
SCHEMAS=`/usr/bin/find /etc/gconf/schemas ! -type d -follow \
-name '*.schemas' 2>/dev/null`
ENTRIES=`/usr/bin/find /etc/gconf/schemas ! -type d -follow \
-name '*.entries' 2>/dev/null`
else
SCHEMAS=`/usr/bin/find /etc/gconf/schemas -name '*.schemas' ! -type d`
ENTRIES=`/usr/bin/find /etc/gconf/schemas -name '*.entries' ! -type d`
fi
if [ -n "$SCHEMAS" ]; then
test -x /usr/bin/gconftool-2 || {
echo "gconftool-2 not installed"
return
}
echo "Updating GConf cache for the following schemas:"
echo "$SCHEMAS" | /bin/sed -e 's/^/ /'
# redirect stdout to /dev/null because gconftool is too verbose
# errors are printed to stderr
GCONF_CONFIG_SOURCE=xml:merged:/etc/gconf/gconf.xml.defaults \
/usr/bin/gconftool-2 --makefile-install-rule $SCHEMAS > /dev/null
if [ $? -ne 0 ]; then
echo "gconftool-2 exited with an error while installing schemas"
exit $SMF_EXIT_ERR_FATAL
else
echo "Schema files merged in the GConf cache"
fi
fi
if [ -n "$ENTRIES" ]; then
test -x /usr/bin/gconftool-2 || {
echo "gconftool-2 not installed"
return
}
echo "Updating GConf cache for the following entries:"
echo "$ENTRIES" | /bin/sed -e 's/^/ /'
# redirect stdout to /dev/null because gconftool is too verbose
# errors are printed to stderr
/usr/bin/gconftool-2 --direct \
--config-source=xml:merged:/etc/gconf/gconf.xml.defaults \
--load $ENTRIES > /dev/null
if [ $? -ne 0 ]; then
echo "gconftool-2 exited with an error while adding entries"
exit $SMF_EXIT_ERR_FATAL
else
echo "Entries merged into the GConf cache"
fi
fi
}
METHOD=$1
case "$METHOD" in
'start')
# Continue with rest of script
;;
'refresh')
;;
-*)
echo $USAGE
exit 2
;;
*)
echo "Invalid method $METHOD"
exit 2
;;
esac
${METHOD}_gconf_cache
exit $SMF_EXIT_OK